/*~!DO NOT EDIT!~
* This file was automatically generated by GSharpDSL.
* No changes will be saved on next compilation.
* @Zestas Orestis.
*/

using System;
using System.Collections;
using GraphLibrary;
using System.Collections.Generic;
using GraphLibrary.Algorithms;

namespace GSharpDSL {

    public class TestFordQueryInfo : CGraphQueryInfo<GraphLibrary.Algorithms.NodePathInfo,System.Nullable<System.Int32>,System.Collections.Generic.Dictionary<GraphLibrary.CGraphNode,System.Collections.Generic.Dictionary<GraphLibrary.CGraphNode,GraphLibrary.Algorithms.Path>>> {    
        //CONSTRUCTOR    
        public TestFordQueryInfo(CGraph graph, object key) : base(graph,key) { }    

        //NODE ACCESSORS        
        public System.Nullable<System.Int32> MDistance(CGraphNode node) {        
            return Info(node).MDistance;        
        }        
        public GraphLibrary.CGraphNode MPredecessor(CGraphNode node) {        
            return Info(node).MPredecessor;        
        }        
        //NODE MODIFIERS        
        public void SetMDistance(CGraphNode node, System.Nullable<System.Int32> MDistance) {        
            Info(node).MDistance = MDistance;
        }        
        public void SetMPredecessor(CGraphNode node, GraphLibrary.CGraphNode MPredecessor) {        
            Info(node).MPredecessor = MPredecessor;        
        }        
        //WHOLE GRAPH INFO ACCESSOR        
        public System.Collections.Generic.Dictionary<GraphLibrary.CGraphNode,System.Collections.Generic.Dictionary<GraphLibrary.CGraphNode,GraphLibrary.Algorithms.Path>> ShortestPaths() {        
            return Info();        
        }

    }
    //CGraphAlgorithm    
    public partial class TestFord : CGraphAlgorithm<int> {    
        private TestFordQueryInfo _outputTestFordQueryInfo;    

        //CGraphAlgorithm CONSTRUCTOR        
        public TestFord(CGraph graph, object graphKEY) {        
            _outputTestFordQueryInfo = new TestFordQueryInfo(graph, graphKEY);        
        }        
        //CGraphAlgorithm NODE ACCESSORS        
        protected System.Nullable<System.Int32> MDistance(CGraphNode node) {        
            return _outputTestFordQueryInfo.MDistance(node);        
        }        
        protected GraphLibrary.CGraphNode MPredecessor(CGraphNode node) {        
            return _outputTestFordQueryInfo.MPredecessor(node);        
        }        
        //CGraphAlgorithm NODE MODIFIERS        
        protected void SetMDistance(CGraphNode node, System.Nullable<System.Int32> MDistance) {        
            _outputTestFordQueryInfo.SetMDistance(node, MDistance);        
        }        
        protected void SetMPredecessor(CGraphNode node, GraphLibrary.CGraphNode MPredecessor) {        
            _outputTestFordQueryInfo.SetMPredecessor(node, MPredecessor);        
        }        

    }

}
